package asm

import "maps"

// Merge combines the contents of this assembler with another one.
func (a *Assembler) Merge(b *Assembler) {
	maps.Copy(a.Data, b.Data)
	from := len(a.Instructions)
	a.Instructions = append(a.Instructions, b.Instructions...)

	for i := from; i < len(a.Instructions); i++ {
		switch a.Instructions[i].Type {
		case TypeLabel:
			a.Instructions[i].Index += Index(len(a.Param.Label))
		case TypeNumber:
			a.Instructions[i].Index += Index(len(a.Param.Number))
		case TypeRegister:
			a.Instructions[i].Index += Index(len(a.Param.Register))
		case TypeRegisterLabel:
			a.Instructions[i].Index += Index(len(a.Param.RegisterLabel))
		case TypeRegisterNumber:
			a.Instructions[i].Index += Index(len(a.Param.RegisterNumber))
		case TypeRegisterRegister:
			a.Instructions[i].Index += Index(len(a.Param.RegisterRegister))
		case TypeMemory:
			a.Instructions[i].Index += Index(len(a.Param.Memory))
		case TypeMemoryLabel:
			a.Instructions[i].Index += Index(len(a.Param.MemoryLabel))
		case TypeMemoryNumber:
			a.Instructions[i].Index += Index(len(a.Param.MemoryNumber))
		case TypeMemoryRegister:
			a.Instructions[i].Index += Index(len(a.Param.MemoryRegister))
		}
	}

	a.Param.Label = append(a.Param.Label, b.Param.Label...)
	a.Param.Number = append(a.Param.Number, b.Param.Number...)
	a.Param.Register = append(a.Param.Register, b.Param.Register...)
	a.Param.RegisterLabel = append(a.Param.RegisterLabel, b.Param.RegisterLabel...)
	a.Param.RegisterNumber = append(a.Param.RegisterNumber, b.Param.RegisterNumber...)
	a.Param.RegisterRegister = append(a.Param.RegisterRegister, b.Param.RegisterRegister...)
	a.Param.Memory = append(a.Param.Memory, b.Param.Memory...)
	a.Param.MemoryLabel = append(a.Param.MemoryLabel, b.Param.MemoryLabel...)
	a.Param.MemoryNumber = append(a.Param.MemoryNumber, b.Param.MemoryNumber...)
	a.Param.MemoryRegister = append(a.Param.MemoryRegister, b.Param.MemoryRegister...)
}
