package core

import (
	"git.urbach.dev/cli/q/src/asm"
)

// BeforeCall pushes used registers to the stack.
func (f *Function) BeforeCall() {
	for _, register := range f.CPU.Output {
		f.SaveRegister(register)
	}

	for _, register := range f.CPU.General {
		if f.RegisterIsUsed(register) {
			f.Register(asm.PUSH, register)
		}
	}
}
