package core

import (
	"git.urbach.dev/cli/q/src/expression"
)

// FoldConstant tries to find a constant that can be folded.
func (f *Function) FoldConstant(expr *expression.Expression) error {
	left := expr.Children[0]
	right := expr.Children[1]
	leftText := left.Token.Text(f.File.Bytes)
	rightText := right.Token.Text(f.File.Bytes)
	constant, exists := f.All.Constants[f.Package+"."+leftText+"."+rightText]

	if !exists {
		return nil
	}

	value, err := ToNumber(constant.Token, constant.File)
	expr.Value = value
	expr.IsFolded = true
	return err
}
