package core

import (
	"git.urbach.dev/cli/q/src/dll"
	"git.urbach.dev/cli/q/src/fs"
	"git.urbach.dev/cli/q/src/register"
	"git.urbach.dev/cli/q/src/set"
	"git.urbach.dev/cli/q/src/token"
)

// Function is the smallest unit of code.
type Function struct {
	register.Machine
	Package      string
	Name         string
	UniqueName   string
	All          *Environment
	File         *fs.File
	Body         token.List
	Input        []*Parameter
	Output       []*Parameter
	Dependencies set.Ordered[*Function]
	DLLs         dll.List
	Err          error
	deferred     []func()
	count        count
}
