package riscv

import "git.urbach.dev/cli/q/src/cpu"

const (
	Zero cpu.Register = iota // hardwired zero
	RA                       // return address
	SP                       // stack pointer
	GP                       // global pointer
	TP                       // thread pointer
	T0                       // temporary register 0
	T1                       // temporary register 1
	T2                       // temporary register 2
	S0                       // saved register 0 / frame pointer
	S1                       // saved register 1
	A0                       // function argument 0 / return value 0
	A1                       // function argument 1 / return value 1
	A2                       // function argument 2
	A3                       // function argument 3
	A4                       // function argument 4
	A5                       // function argument 5
	A6                       // function argument 6
	A7                       // function argument 7
	S2                       // saved register 2
	S3                       // saved register 3
	S4                       // saved register 4
	S5                       // saved register 5
	S6                       // saved register 6
	S7                       // saved register 7
	S8                       // saved register 8
	S9                       // saved register 9
	S10                      // saved register 10
	S11                      // saved register 11
	T3                       // temporary register 3
	T4                       // temporary register 4
	T5                       // temporary register 5
	T6                       // temporary register 6
)

var (
	SyscallInputRegisters  = []cpu.Register{A7, A0, A1, A2, A3, A4, A5, A6}
	SyscallOutputRegisters = []cpu.Register{A0, A1}
)
